%ifarch x86_64
%define gtm_dist /opt/lsb-gtm/V5.3-004A_x86_64
%else
%define gtm_dist /opt/lsb-gtm/V5.3-004A_i686
%endif

Name:		fis-gtm-5.3004a
Version:	5.3004a
Release:	2
Summary:	High end TP schemaless database
License:	AGPL
Vendor:		Fidelity Information Services
URL:		http://www.fidelityinfoservices.com/FNFIS/Markets/NonFinancialIndustries/Healthcare/GTM/
Group:		Applications/Databases
Packager:	Jonathan Tai <jon.tai@medsphere.com>

Provides:	fis-gtm

Requires(pre):		/usr/sbin/groupadd
Requires(post):		/usr/sbin/semanage, /sbin/restorecon
Requires(postun):	/usr/sbin/semanage, /usr/sbin/groupdel

Requires:	/bin/sh, coreutils, libicu, zlib, ncurses, gpgme, libgpg-error, libgcrypt
BuildRequires:	/bin/tcsh, gcc, libicu-devel, zlib-devel, ncurses-devel, gpgme-devel, libgpg-error-devel, libgcrypt-devel, fis-gtm-5.3004a

%ifarch x86_64
BuildRequires:	elfutils-libelf-devel
%endif

# The source for both i686 and x86_64 versions are both in this tarball, even
# though the tarball is named i686_src
Source:		gtm_V53004A_linux_i686_src.tar.gz

# Patch the configure script to pre-answer all of the prompts and set the
# installation directory
Patch1:		fis-gtm-5.3004a_noninteractive-configure.patch

BuildRoot:	%{_tmppath}/%{name}-root

%description
GT.M is a vetted, industrial strength, transaction processing application
platform consisting of a schema-less database engine optimized for extreme
transaction processing throughput & business continuity plus a compiler for the
MUMPS language.

%prep
# This should be guaranteed by BuildRequires: fis-gtm-5.3004a
if [ ! -d "%{gtm_dist}" ]; then
    echo "existing binary installation of GT.M not found at %{gtm_dist}"
    exit 1
fi

# This should be guaranteed by BuildRequires: fis-gtm-5.3004a
if ! getent group gtm >/dev/null; then
    echo "gtm group not found in /etc/group"
    exit 1
fi

if [ `/usr/bin/id -u` -ne 0 ]; then
    echo "this RPM must be built as root"
    exit 1
fi
%setup -c

%build
# GT.M needs to be built with tcsh, and with a bunch of environmental variables
# set.  Since we can't run tcsh interactively, we put all the setenv commands
# and the build command itself into a temporary script, then execute it with
# tcsh.
echo 'setenv gtm_curpro %{gtm_dist}' > build.csh
echo 'setenv gtm_exe %{gtm_dist}' >> build.csh
echo 'setenv HOSTOS '$(uname -s) >> build.csh
echo 'setenv gtm_tools '$(pwd)'/sr_linux' >> build.csh
echo 'setenv gtm_inc '$(pwd)'/sr_linux' >> build.csh
%ifarch x86_64
echo 'setenv OBJECT_MODE 64' >> build.csh
%endif
echo 'setenv gtm_icu_version '$(icu-config --version) >> build.csh
echo 'setenv gtm_version_change 1' >> build.csh
cat sr_unix/gtm_env.csh >> build.csh
echo 'make -f sr_unix/comlist.mk -I./sr_unix -I./sr_linux buildtypes=pro gtm_ver='$(pwd) >> build.csh
tcsh -b build.csh
rm -f build.csh

# Put a copy of the COPYING file in the pro directory so that it will be
# installed by the ./configure script later
cp COPYING pro

%install
rm -rf %{buildroot}

# Move the existing GT.M installation out of the way
rm -rf %{gtm_dist}.bak
mv %{gtm_dist} %{gtm_dist}.bak

# We need to patch the configure script to pre-answer all of the prompts and
# set the installation directory
cd pro
cat %{PATCH1} | sed 's,@GTM_DIST@,%{gtm_dist},' | sed 's,@GTM_ICU_VERSION@,'$(icu-config --version)',' | patch -p0 -b
chmod +x configure
./configure

mkdir -p %{buildroot}$(dirname %{gtm_dist})
mv %{gtm_dist} %{buildroot}$(dirname %{gtm_dist})

# Restore the existing GT.M installation
mv %{gtm_dist}.bak %{gtm_dist}

%clean
rm -rf %{buildroot}

%files
%defattr(-,-,-)
/opt/lsb-gtm

%pre
/usr/sbin/groupadd gtm 2> /dev/null || :

%post
# GT.M's installation script just chcon directly, but it won't have any effect
# on the target system (only on the build system, and then only if SELinux is
# enabled on the build system).  On the target system, we should use semanage
# to save the correct context for libgtmshr.so in the SELinux policy.  This
# will ensure that the file has the correct context, even after relabling.
#
# See http://fedoraproject.org/wiki/PackagingDrafts/SELinux
/usr/sbin/semanage fcontext -a -t textrel_shlib_t %{gtm_dist}/libgtmshr.so 2>/dev/null || :
/sbin/restorecon %{gtm_dist}/libgtmshr.so || :

%postun
if [ $1 -eq 0 ]; then
    # Remove libgtmshr.so from the SELinux policy if we're removing the package
    # See http://fedoraproject.org/wiki/PackagingDrafts/SELinux
    /usr/sbin/semanage fcontext -d -t textrel_shlib_t %{gtm_dist}/libgtmshr.so 2>/dev/null || :

    # if we were the last GT.M package on the system, remove the gtm group
    if [ ! -d /opt/lsb-gtm ]; then
        /usr/sbin/groupdel gtm 2> /dev/null || :
    fi
fi
